<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

error_reporting(E_ALL);

$path = dirname(__FILE__).'/../';
// let's use a constant instead of a variable so that hacker can't use it to inject something using a require
// on an unprotected directory
define('wc_inc_path', $path);
unset($path);

require wc_inc_path.'/inc/classes/util.class.php';
util::sessionWorkaround(wc_inc_path);

@ini_set('display_errors','on');
@ini_set('session.use_cookies','1');
@ini_set('session.use_only_cookies','1');
@ini_set('url_rewriter.tags','');
@ini_set('session.use_trans_sid', '0');
session_start();

require wc_inc_path.'inc/lib/constants.lib.php';

// conf
require wc_inc_path.'inc/classes/WiclearIni.conf.php';
require wc_inc_path.'inc/classes/ini.class.php';
$ini = new ini(wc_inc_path.'conf/config.ini');
$ini->importConstants();

require wc_inc_path.'/inc/lib/url.lib.php';
$app_path = createWebAppPath();
$admin_app_path = $app_path.'admin/';

// chrono
require wc_inc_path.'inc/classes/chrono.class.php';

// db
require wc_inc_path.'inc/classes/db_connection.class.php';
require wc_inc_path.'inc/classes/mysql.class.php';
$con = new mysql(wc_db_host, wc_db_login, wc_db_password, wc_db_database);

// wiki
require wc_inc_path.'inc/classes/user.class.php';
require wc_inc_path.'inc/classes/wiki.class.php';
require wc_inc_path.'inc/lib/variables.lib.php';
$wiki = new wiki($con, wc_db_prefix);

$ips           = varPost('ips');
$random        = varPost('random');
$date          = time();
$ipsSession    = varSession('login_ips');
unsetVarSession('login_ip');
$randomSession = varSession('login_random');
unsetVarSession('login_random');
$dateSession   = varSession('login_date');
unsetVarSession('login_date');

if (($date - $dateSession) < wc_login_timeout && $ips == $ipsSession && $random == $randomSession)
{
  $login         = varPost('login');
  $password      = varPost('password');
  $user = $wiki->findUser($login, $password);

  if ($user->isAdmin())
  {
    // logged in
    // set the required info in session
    setVarSession('user_id', $user->id);
    setVarSession('user_password', $user->password);

    session_write_close();
    header('Location: '.$admin_app_path.'index.php');
    return;
  }
}

header('Location: '.$admin_app_path.'login.php');
?>
