<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

/**
 * \brief handles plugin description
 *
 * desc files have the same format as translation files
 * But only several fields are meaningfull :
 * <ul>
 *   <li>Name</li>
 *   <li>Author</li>
 *   <li>Description</li>
 *   <li>Icon</li>
 * </ul>
 */

class desc extends translation
{
  function desc($file)
  {
    if (file_exists($file))
    {
      $this->readFile($file);
    }
  }

  function getName()
  {
    return $this->get('Name');
  }

  function getAuthor()
  {
    return $this->get('Author');
  }

  function getDescription()
  {
    return $this->get('Description');
  }

  function getIcon()
  {
    return $this->get('Icon');
  }
}

?>