<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

$adminBoxHandle['ban']           = 'banDisplay';

$adminActionHandle['ban_delete'] = 'onBanDelete';
$adminActionHandle['ban_add']    = 'onBanAdd';

function banDisplay()
{
  global $wiki;

  $bannedIps = $wiki->getBannedIps();

  $form = new form(createAdminURL(array('mode'=>'ban_add')), 'post');

  $form->addFieldset();
  $form->addLegend(tr('Banned IPs'));

  if (empty($bannedIps))
  {
    $form->addHtml('<h1>'.tr('No banned IPs yet').'</h1>');
  }
  else
  {
    $blob =
    '<table>'.
    '<tr><th>'.tr('Ip').'</th><th>'.tr('Delete').'</th></tr>';

    foreach ($bannedIps as $bannedIp)
    {
      $blob .=
      '<tr>'.
        '<td>'.$bannedIp[1].'</td>'.
        '<td><a href="'.createAdminURL(array('mode'=>'ban_delete', 'id'=>$bannedIp[0])).'">'.tr('delete').'</a></td>'.
      '</tr>';
    }

    $blob .=
    '</table>';

    $form->addHtml($blob);
  }

  $form->addHtml('<p class="field">');
  $form->addHidden('check', '1');
  $form->addHtml('</p>');
  $form->addHtml('<p class="field">');
  $form->addButton('AddBan', tr('Add ban'), 'action');
  $form->addInput('ban_ip', 'Ip to ban');
  $form->addHtml('</p>');
  $form->addHtml('<p class="field"/>');

  return $form->toHtml();
}

function onBanDelete()
{
  global $wiki;

  $id = varGet('id');
  $wiki->delBan($id);
  header('Location: '.createHeaderAdminURL(array('mode'=>'ban')));
}

function onBanAdd()
{
  if (!isset($_POST['check']))
  {
    return;
  }

  global $wiki;

  $ip = varPost('ban_ip');
  $wiki->addBan($ip);
  header('Location: '.createHeaderAdminURL(array('mode'=>'ban')));
}
?>