<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

require wc_inc_path.'admin/inc/lib/url.lib.php';
require wc_inc_path.'inc/lib/format.lib.php';
require wc_inc_path.'inc/lib/user_preferences.lib.php';
require wc_inc_path.'inc/lib/lang_helper.lib.php';
require wc_inc_path.'inc/classes/form.class.php';
require wc_inc_path.'inc/classes/metadata.class.php';
require wc_inc_path.'admin/inc/lib/wiki_preferences.lib.php';
require wc_inc_path.'admin/inc/lib/user_preferences.lib.php';
require wc_inc_path.'admin/inc/lib/langs.lib.php';
require wc_inc_path.'admin/inc/lib/users.lib.php';
require wc_inc_path.'admin/inc/lib/groups.lib.php';
require wc_inc_path.'admin/inc/lib/meta_data.lib.php';
require wc_inc_path.'admin/inc/lib/db_maintenance.lib.php';
require wc_inc_path.'admin/inc/lib/tools.lib.php';
require wc_inc_path.'admin/inc/lib/logoff.lib.php';
require wc_inc_path.'admin/inc/lib/ban.lib.php';

function handleAdminAction()
{
  global $user;

  if (!$user->isAdmin())
  {
    global $admin_app_path;
    header('Location: '.$admin_app_path.'login.php');
    return;
  }

  global $mode;

  if (empty($mode))
  {
    return;
  }

  global $adminActionHandle;;
  if (array_key_exists($mode, $adminActionHandle))
  {
    $adminActionHandle[$mode]();
  }
}

function menuBox()
{
  global $mode;

  if (empty($mode))
  {
    $mode = 'main';
  }

  return
  '<ul>'.
    '<li'.($mode=='main'?'  class="selected"':'').'><a href="'.createAdminURL().'">'.tr('Main').'</a></li>'.
    '<li'.($mode=='langs'?'  class="selected"':'').'><a href="'.createAdminURL(array('mode'=>'langs')).'">'.tr('Langs').'</a></li>'.
    '<li'.($mode=='users'?'  class="selected"':'').'><a href="'.createAdminURL(array('mode'=>'users')).'">'.tr('Users').'</a></li>'.
    '<li'.($mode=='groups'?'  class="selected"':'').'><a href="'.createAdminURL(array('mode'=>'groups')).'">'.tr('Groups').'</a></li>'.
    '<li'.($mode=='meta'?'  class="selected"':'').'><a href="'.createAdminURL(array('mode'=>'meta')).'">'.tr('Meta data').'</a></li>'.
    '<li'.($mode=='ban'?'  class="selected"':'').'><a href="'.createAdminURL(array('mode'=>'ban')).'">'.tr('Ban').'</a></li>'.
    '<li'.($mode=='db'?'  class="selected"':'').'><a href="'.createAdminURL(array('mode'=>'db')).'">'.tr('Db maintenance').'</a></li>'.
    '<li'.($mode=='wiki_pref'?'  class="selected"':'').'><a href="'.createAdminURL(array('mode'=>'wiki_pref')).'">'.tr('Preferences').'</a></li>'.
    '<li'.($mode=='tools'?'  class="selected"':'').'><a href="'.createAdminURL(array('mode'=>'tools')).'">'.tr('Tools').'</a></li>'.
    '<li><a href="'.createAdminURL(array('mode'=>'logoff')).'">'.tr('Logout').'</a></li>'.
  '</ul>';
}

function contentBox()
{
  global $adminBoxHandle;
  global $mode;

  if (!empty($mode))
  {
    if (array_key_exists($mode, $adminBoxHandle))
    {
      $blob = $adminBoxHandle[$mode]();
    }
  }

  if (empty($blob))
  {
    // if main page
    $version_file = '../VERSION';
    if (file_exists($version_file))
    {
      $version_content = file($version_file);
      $version = $version_content[0];
    }
    else
    {
      $version = tr('Unknown (the VERSION file is inaccessible)');
    }

    $blob =
    '<div class="main">'.
    '<h1>'.tr('Welcome to').' '.wc_wiki_name.' '.tr('panel admin').'</h1>'.
    '<p>'.tr('Installed version is').' '.$version.'</p>'.
    '</div>';
  }

  // always display a button to get back to wiki
  global $admin_app_path;
  $form = new form($admin_app_path.'..', 'post', 'cancel');
  $form->addFieldset();
  $form->addLegend(tr('Get back to wiki'));

  $form->addHtml('<p class="field">');
  $form->addButton('submit', tr('Get back to wiki'), 'submit');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field"/>');
  $blob .= $form->toHtml();

  return $blob;
}
?>
