<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

$adminBoxHandle['db']    = 'dbMaintenance';

$adminActionHandle['db'] = 'onDbMaintenance';

function dbMaintenance()
{
  $form = new form(createAdminURL(array('mode'=>'db')), 'post');
  $form->addFieldset();
  $form->addLegend(tr('Db maintenance'));

  if (existVarSession('error'))
  {
    $error = varSession('error');
    $form->addHtml('<h1>'.$error.'</h1>');
    unsetVarSession('error');
  }

  $form->addButton('check_db', tr('Check and repair db'));
  $form->addFieldset();
  $form->addButton('canonize_db', tr('Canonize db'));
  $form->addHidden('check', '1');
  return $form->toHtml();
}

function onDbMaintenance()
{
  if (!isset($_POST['check']))
  {
    return;
  }

  global $wiki;

  if (isset($_POST['check_db']))
  {
    $wiki->computeNestedSetModel();
  }
  else
  if (isset($_POST['canonize_db']))
  {
    if (!$wiki->canonize())
    {
      setVarSession('error', tr('An error occured').' '.$wiki->con->error);
    }
    else
    {
      setVarSession('error', tr('Canonisation successfully executed'));
    }
  }
}
?>