<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

$adminBoxHandle['langs']           = 'langsDisplay';
$adminBoxHandle['lang_edit']       = 'langEdit';
$adminBoxHandle['lang_delete']     = 'langDelete';

$adminActionHandle['lang_add']     = 'onLangAdd';
$adminActionHandle['lang_delete2'] = 'onLangDelete';
$adminActionHandle['lang_edit']    = 'onLangEdit';

function langsDisplay()
{
  global $wiki;

  $form = new form(createAdminURL(array('mode'=>'lang_add')), 'post', 'langs');

  if (existVarSession('error'))
  {
    $error = varSession('error');
    unsetVarSession('error');

    $form->addHtml('<p>'.$error.'</p>');
  }

  $form->addFieldset();
  $form->addLegend(tr('Langs'));

  $form->addHtml(
    '<table>'.
    '<tr><th>'.tr('Code').'</th><th>'.tr('Description').'</th><th>'.tr('Flag').'</th><th>'.tr('Delete').'</th></tr>'
  );

  $langs = $wiki->getLangs();

  foreach ($langs as $l)
  {
    $langClass = '';
    if ($l->code == wc_default_lang)
    {
      $langClass = 'current';
    }

    $form->addHtml(
    '<tr class="'.$langClass.'">'.
      '<td><a href="'.createAdminURL(array('mode'=>'lang_edit',   'id'=>$l->id)).'">'.$l->code.'</a></td>'.
      '<td><a href="'.createAdminURL(array('mode'=>'lang_edit',   'id'=>$l->id)).'">'.$l->description.'</a></td>'.
      '<td><a href="'.createAdminURL(array('mode'=>'lang_edit',   'id'=>$l->id)).'">'.$l->flag.'</a></td>'.
      '<td><a href="'.createAdminURL(array('mode'=>'lang_delete', 'id'=>$l->id)).'">'.tr('Delete').'</a></td>'.
    '</tr>'
    );
  }

  $form->addHtml('<tr><td>');
  $form->addInput('code', 'Code');
  $form->addHtml('</td><td>');
  $form->addInput('description', 'Description');
  $form->addHtml('</td><td>');
  $form->addInput('flag', 'Flag');
  $form->addHtml('</td><td></td></tr>');

  $form->addHtml(
  '</table>'.
  '<p class="field">'
  );
  $form->addHidden('check', '1');
  $form->addHtml(
  '</p>'.
  '<p class="field">'
  );
  $form->addButton(tr('Add lang'), '', 'action');
  $form->addHtml(
  '</p>'.
  '<p class="field"/>'
  );

  return $form->toHtml();
}

function langEdit()
{
  global $wiki;

  if (!isset($_GET['id']))
  {
    return;
  }
  $id = varGet('id');
  $lang = $wiki->getLangById($id);

  $form = new form(createAdminURL(array('mode'=>'lang_edit')), 'post', 'langs');
  $form->addFieldset();
  $form->addLegend(tr('Edit lang'));

  $form->addHtml(
    '<table>'.
    '<tr><th>'.tr('Code').'</th><th>'.tr('Description').'</th><th>'.tr('Flag').'</th><th>'.tr('Delete').'</th></tr>'
  );

  $form->addHtml('<tr>');
  $form->addHtml('<td>');
  $form->addInput('code', 'Code', $lang->code);
  $form->addHtml('</td>');
  $form->addHtml('<td>');
  $form->addInput('description', 'Description', $lang->description);
  $form->addHtml('</td>');
  $form->addHtml('<td>');
  $form->addInput('flag', 'Flag', $lang->flag);
  $form->addHtml('</td>');
  $form->addHtml('<td><a href="'.createAdminURL(array('mode'=>'lang_delete', 'id'=>$lang->id)).'">'.tr('Delete').'</a></td>');
  $form->addHtml('</tr>');

  $form->addHtml(
  '</table>'.
  '<p class="field">'
  );
  $form->addHidden('id', $id);
  $form->addHidden('check', '1');
  $form->addHtml(
  '</p>'.
  '<p class="field">'
  );
  $form->addButton(tr('Modify lang'), '', 'action');
  $form->addHtml(
  '</p>'.
  '<p class="field"/>'
  );

  return $form->toHtml();
}

function langDelete()
{
  if (!isset($_GET['id']))
  {
    return;
  }

  $form = new form(createAdminURL(array('mode'=>'lang_delete2')), 'post', 'langs');
  $form->addFieldset();
  $form->addLegend(tr('Delete lang'));

  $form->addHtml('<p class="field">');
  $form->addHidden('id', varGet('id'));
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addHidden('check', '1');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('Warning : all pages of that lang will be destroyed'));
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addButton('submit', tr('Delete lang'), 'submit');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field"/>');

  return $form->toHtml();
}

function onLangAdd()
{
  if (!isset($_POST['check']))
  {
    return;
  }

  global $wiki;

  $code        = varPost('code');
  $description = varPost('description');
  $flag        = varPost('flag');

  if ($wiki->langExist($code))
  {
    setVarSession('error', tr('Lang').' '.$code.' '.tr('already exists'));
    session_write_close();
    header('Location: '.createHeaderAdminURL(array('mode'=>'langs')));
    return;
  }

  $id = $wiki->addLang($code, $description, $flag);
  header('Location: '.createHeaderAdminURL(array('mode'=>'langs')));
}

function onLangDelete()
{
  if (!isset($_POST['check']))
  {
    return;
  }

  if (!isset($_POST['id']))
  {
    return;
  }

  global $wiki;

  $id = varPost('id');
  $lang = $wiki->getLangById($id);
  if ($lang->code == wc_default_lang)
  {
    setVarSession('error', tr('Lang').' '.$lang->code.' '.tr('cannot be deleted, it is set as the default lang in preferences'));
    session_write_close();
    header('Location: '.createHeaderAdminURL(array('mode'=>'langs')));
    return;
  }

  $wiki->delLang($id);
  header('Location: '.createHeaderAdminURL(array('mode'=>'langs')));
}

function onLangEdit()
{
  if (!isset($_POST['check']))
  {
    return;
  }

  global $wiki;
  $id          = varPost('id');
  $code        = varPost('code');
  $description = varPost('description');
  $flag        = varPost('flag');

  $lang = $wiki->getLangById($id);
  $wiki->modifyLang($id, $code, $description, $flag);
  if ($lang->code == wc_default_lang)
  {
    global $ini;

    // change new default lang code in ini file
    $ini->addConstant('wc_default_lang', $code);
    $ini->forceSaveFile();
  }
  header('Location: '.createHeaderAdminURL(array('mode'=>'langs')));
}
?>