<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

$adminBoxHandle['meta']                  = 'metasDisplay';
$adminBoxHandle['meta_values']           = 'metaValues';
$adminBoxHandle['meta_view']             = 'metaDisplay';

$adminActionHandle['meta_delete']        = 'onMetaDelete';
$adminActionHandle['meta_update']        = 'onMetaUpdate';
$adminActionHandle['meta_add']           = 'onMetaAdd';
$adminActionHandle['meta_values_delete'] = 'onMetaValuesDelete';
$adminActionHandle['meta_values_add']    = 'onMetaValuesAdd';

function metasDisplay()
{
  global $wiki;

  $metas = $wiki->getMetaDatas();

  $form = new form(createAdminURL(array('mode'=>'meta_update')), 'post');

  if (existVarSession('error'))
  {
    $error = varSession('error');
    $form->addHtml('<h1>'.$error.'</h1>');
    unsetVarSession('error');
  }

  $form->addFieldset();
  $form->addLegend(tr('Metadatas'));

  if (empty($metas))
  {
    $form->addHtml('<h1>'.tr('No metadata yet').'</h1>');
  }
  else
  {
    $form->addHtml(
    '<table>'.
    '<tr><th>'.tr('Metadata').'</th><th>'.tr('Type').'</th><th>'.tr('Values').'</th><th>'.tr('Delete').'</th></tr>'
    );

    $metadataTypeValues = array(
      'open' => metadata_open,
      'close' => metadata_close
    );

    foreach ($metas as $m)
    {
      $form->addHtml(
      '<tr>'.
        '<td><a href="'.createAdminURL(array('mode'=>'meta_view',   'id'=>$m->id)).'">'.$m->name.'</a></td>'.
        '<td>'
      );

      $form->addDropDown($metadataTypeValues, $m->type, $m->id);

      $form->addHtml(
        '</td><td>'
      );

      if ($m->type == metadata_close)
      {
        $form->addHtml(
          '<a href="'.createAdminURL(array('mode'=>'meta_values', 'id'=>$m->id)).'">'.tr('values').'</a>'
        );
      }

      $form->addHtml(
        '</td>'.
        '<td><a href="'.createAdminURL(array('mode'=>'meta_delete', 'id'=>$m->id)).'">'.tr('delete').'</a></td>'.
      '</tr>'
      );
    }

    $form->addHtml('</table>');
  }

  $form->addHtml('<p class="field">');
  $form->addHidden('check', '1');
  $form->addHtml('</p>');
  $form->addHtml('<p class="field">');
  $form->addButton('update_meta', tr('Update metadata'), 'action');
  $form->addHtml('</p>');
  $form->addHtml('<p class="field"/>');

  $form2 = new form(createAdminURL(array('mode'=>'meta_add')), 'post');
  $form2->addFieldset();
  $form2->addLegend(tr('Add metadata'));
  $form2->addHtml('<p class="field">');
  $form2->addHidden('check', '1');
  $form2->addHtml('</p>');
  $form2->addHtml('<p class="field">');
  $form2->addButton('add_meta', tr('Add metadata'), 'action');
  $form2->addInput('metadata_name', 'Metadata name');
  $form2->addHtml('</p>');
  $form2->addHtml('<p class="field"/>');

  return $form->toHtml().$form2->toHtml();
}

function metaValues()
{
  global $wiki;

  if (empty($_GET['id']))
  {
    return;
  }

  $id = varGet('id');

  $metadata = $wiki->getMetaDataById($id);
  $values   = $wiki->getClosedMetadataValues($id);

  $values = array_flip($values);

  $form = new form(createAdminURL(array('mode'=>'meta_values_delete', 'id'=>$id)), 'post', 'metadata_delete');
  $form->addFieldset();
  $form->addLegend($metadata->name.' : '.tr('Remove values'));

  $form->addHtml('<p class="field">');
  $form->addListBox($values, array(), 'values', 10);
  $form->addHtml('</p>');
  $form->addHtml('<p class="field">');
  $form->addButton('del_meta_values', tr('Remove selected'));
  $form->addHtml('</p>');
  $form->addHidden('check', '1');
  $form->addHtml('<p class="field"/>');

  $form2 = new form(createAdminURL(array('mode'=>'meta_values_add', 'id'=>$id)), 'post');
  $form2->addFieldset();
  $form2->addLegend($metadata->name.' : '.tr('Add value'));
  $form2->addHtml('<p class="field">');
  $form2->addHidden('check', '1');
  $form2->addHtml('</p>');
  $form2->addHtml('<p class="field">');
  $form2->addButton('add_meta_value', tr('Add Value'), 'action');
  $form2->addInput('metadata_value', 'Metadata value');
  $form2->addHtml('</p>');
  $form2->addHtml('<p class="field"/>');

  return $form->toHtml().$form2->toHtml();
}

function metaDisplay()
{
  // metaDisplay wait for an id via GET, but we're coming from a form
  // with the id named meta_datas
  if (empty($_GET['id']))
  {
    return;
  }

  $id = varGet('id');

  global $wiki;
  $metadata = $wiki->getMetadataById($id);

  if ($metadata->type == metadata_open)
  {
    $infos = $wiki->getMetaDataInfoByMetadataId($id);
  }
  else
  {
    $infos = $wiki->getMetaDataClosedInfoByMetadataId($id);
  }

  $blob =
  '<div class="meta">'.
  '<h1>'.tr('Nodes that define metadata').' ['.$metadata->name.']</h1>'.
  '<table>'.
  '<tr><th>'.tr('Node').'</th><th>'.tr('Value').'</th></tr>';

  foreach ($infos as $idValueTitleCode)
  {
    $url = createURL($idValueTitleCode[2], array('lang'=>$idValueTitleCode[3]));

    $blob .=
    '<tr>'.
    '<td><a href="'.$url.'">'.$idValueTitleCode[2].'('.$idValueTitleCode[3].')</a></td>'.
    '<td>'.$idValueTitleCode[1].'</td>'.
    '</tr>';
  }
  $blob .=
  '</table>'.
  '</div>';

  return $blob;
}

function onMetaDelete()
{
  global $wiki;

  $id = varGet('id');
  $wiki->delMetadata($id);
  header('Location: '.createHeaderAdminURL(array('mode'=>'meta')));
}

function onMetaUpdate()
{
  if (empty($_POST['check']))
  {
    return;
  }

  if (empty($_POST['update_meta']))
  {
    return;
  }

  global $wiki;

  $metas = $wiki->getMetaDatas();

  $metaToUpdate = array();
  foreach ($metas as $m)
  {
    $type = varPost($m->id);
    if ($type != $m->type)
    {
      $metaToUpdate[$m->id] = $type;
    }
  }

  $wiki->updateMetadatas($metaToUpdate);
  header('Location: '.createHeaderAdminURL(array('mode'=>'meta')));
}

function onMetaAdd()
{
  if (empty($_POST['check']))
  {
    return;
  }

  if (empty($_POST['add_meta']))
  {
    return;
  }

  global $wiki;
  $metaName = varPost('metadata_name');

  if ($wiki->metaDataExist($metaName))
  {
    setVarSession('error', tr('Metadata').' '.$metaName.' '.tr('already exists'));
    session_write_close();
    header('Location: '.createHeaderAdminURL(array('mode'=>'meta')));
    return;
  }

  $wiki->addMetadata($metaName);
  header('Location: '.createHeaderAdminURL(array('mode'=>'meta')));
}

function onMetaValuesDelete()
{
  if (empty($_POST['check']))
  {
    return;
  }

  if (empty($_POST['del_meta_values']))
  {
    return;
  }

  if (empty($_GET['id']))
  {
    return;
  }

  $id = varGet('id');
  if (!empty($_POST['values']))
  {
    global $wiki;
    $wiki->removeClosedValuesFromMetadata(varPost('values'));
  }

  header('Location: '.createHeaderAdminURL(array('id'=>$id, 'mode'=>'meta_values')));
}

function onMetaValuesAdd()
{
  if (empty($_POST['check']))
  {
    return;
  }

  if (empty($_POST['add_meta_value']))
  {
    return;
  }

  if (empty($_GET['id']))
  {
    return;
  }

  $id = varGet('id');
  $value = varPost('metadata_value');

  global $wiki;
  if (!$wiki->existMetadataClosedValue($id, $value))
  {
    $wiki->addMetadataClosedValue($id, $value);
  }

  header('Location: '.createHeaderAdminURL(array('id'=>$id, 'mode'=>'meta_values')));
}

?>