<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

$adminBoxHandle['tools']    = 'tools';

require wc_inc_path.'admin/inc/classes/desc.class.php';

function getTools($toolsBaseDir)
{
  if (!file_exists($toolsBaseDir))
  {
    return;
  }

  $tools = array();
  $h = opendir($toolsBaseDir);
  while (($file = readdir($h)) !== false)
  {
    if (is_dir($toolsBaseDir.$file) && file_exists($toolsBaseDir.$file.'/desc.conf'))
    {
      $tools[$file] = new desc($toolsBaseDir.$file.'/desc.conf');
    }
  }
  closedir($h);

  return $tools;
}

function tools()
{
  if (isset($_GET['tool']))
  {
    $tool = varGet('tool');
    $file = 'tools/'.$tool.'/index.php';

    if (file_exists($file))
    {
      global $user_lang;

      if (file_exists(wc_inc_path.'admin/tools/'.$tool.'/i18n') && $user_lang != 'en')
      {
        global $translation;
        $translation->completeFrom(wc_inc_path.'admin/tools/'.$tool.'/i18n', $user_lang, 'en', '.lang');
      }

      require wc_inc_path.'admin/'.$file;

      return tr('Tools done');
    }
  }

  $admin_tools = getTools('tools/');
  $site_tools  = getTools('../tools/');
  $tools = array_merge($admin_tools, $site_tools);

  $blob = '<div class="tools">';
  $blob .= '<h1>'.tr('Tools').'</h1>';
  if (sizeof($tools) == 0)
  {
    $blob = tr('No tools are installed');
  }
  else
  {
    $blob .= '<ul>';
    foreach ($tools as $tool=>$desc)
    {
      $blob .= '<li>';
      $blob .= '<img src="tools/'.$tool.'/'.$desc->getIcon().'"/>';
      $blob .= '<h2><a href="'.createToolURL($tool).'">'.$desc->getName().'</a></h2>';
      $blob .= '<h3>'.tr('By').' '.$desc->getAuthor().'</h3>';
      $blob .= '<p>'.$desc->getDescription().'</p>';
      $blob .= '</li>';
    }
    $blob .= '</ul>';
  }
  $blob .= '</div>';

  return $blob;
}

?>