<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

$adminBoxHandle['users']           = 'usersDisplayRights';

$adminActionHandle['user_confirm'] = 'onUserConfirm';
$adminActionHandle['user_delete']  = 'onUserDelete';
$adminActionHandle['users']        = 'onUserChangeRights';

function usersDisplayRights()
{
  global $wiki;
  global $user;

  // id, login, admin, temp_key
  $users = $wiki->getAllUsersRights();

  $form = new form(createAdminURL(array('mode'=>'users')), 'post', 'users');
  $form->addFieldset();
  $form->addLegend(tr("Users' rights"));

  $form->addHtml(
    '<table>'.
    '<tr><th>'.tr('Login').'</th><th>'.tr('Right').'</th><th>'.tr('Confirm').'</th><th>'.tr('Delete').'</th></tr>'
  );

  $rights = array('user'=>user_value, 'moderator'=>moderator_value, 'admin'=>admin_value);

  foreach ($users as $u)
  {
    $form->addHtml(
    '<tr>'.
      '<td><a href="'.createAdminURL(array('mode'=>'user_view', 'id'=>$u[0])).'">'.$u[1].'</a></td>'.
      '<td>'
    );
    $form->addDropDown($rights, $u[2], $u[1]);
    $form->addHtml(
      '</td>'.
      '<td>'
    );

    if (!empty($u[3]))
    {
      $form->addHtml('<a href="'.createAdminURL(array('mode'=>'user_confirm', 'id'=>$u[0])).'">'.tr('Confirm').'</a>');
    }

    $form->addHtml(
      '</td>'.
      '<td>'
    );

    if ($u[0] != $user->id)
    {
      $form->addHtml('<a href="'.createAdminURL(array('mode'=>'user_delete', 'id'=>$u[0])).'">'.tr('Delete').'</a>');
    }

    $form->addHtml(
      '</td>'.
    '</tr>'
    );
  }

  $form->addHtml(
  '</table>'.
  '<p class="field">'
  );
  $form->addHidden('check', '1');
  $form->addHtml(
  '</p>'.
  '<p class="field">'
  );
  $form->addButton('update_rights', tr('Update rights'), 'action');
  $form->addHtml(
  '</p>'.
  '<p class="field"/>'
  );

  return $form->toHtml();
}

function onUserChangeRights()
{
  if (!isset($_POST['check']))
  {
    return;
  }

  global $wiki;

  // id, login, admin, temp_key
  $users = $wiki->getAllUsersRights();
  $usersToUpdate = array();

  foreach ($users as $user)
  {
    $admin = varPost($user[1]);
    if ($user[2] != $admin)
    {
      $info = array();
      array_push($info, $user[0], $admin);
      $usersToUpdate[] = $info;
    }
  }

  $wiki->updateUsersRights($usersToUpdate);
}

function onUserConfirm()
{
  global $wiki;

  if (isset($_GET['id']))
  {
    $id = varGet('id');

    $wiki->confirmUserById($id);
  }

  header('Location: '.createHeaderAdminURL(array('mode'=>'users')));
}

function onUserDelete()
{
  global $wiki;

  if (isset($_GET['id']))
  {
    $id = varGet('id');

    $wiki->deleteUserById($id);
  }

  header('Location: '.createHeaderAdminURL(array('mode'=>'users')));
}
?>