<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

function dumpVariables($string)
{
  echo '<pre>'.$string.' BEGIN</pre>';
  foreach ($_POST as $k=>$v)
  {
    echo '<pre>POST['.$k.']='.$v.'</pre>';
  }
  foreach ($_FILES as $uk=>$ks)
  {
    foreach ($ks as $k=>$v)
    {
      echo '<pre>FILES['.$uk.']['.$k.']='.$v.'</pre>';
    }
  }
  foreach ($_SESSION as $k=>$v)
  {
    echo '<pre>SESSION['.$k.']='.$v.'</pre>';
  }
  foreach ($_GET as $k=>$v)
  {
    echo '<pre>GET['.$k.']='.$v.'</pre>';
  }
  foreach ($_COOKIE as $k=>$v)
  {
    echo '<pre>COOKIE['.$k.']='.$v.'</pre>';
  }
  foreach ($_SERVER as $k=>$v)
  {
    echo '<pre>SERVER['.$k.']='.$v.'</pre>';
  }
  echo '<pre>'.$string.' END</pre>';
}

@ini_set('session.use_cookies','1');
@ini_set('session.use_only_cookies','1');
@ini_set('url_rewriter.tags','');
@ini_set('session.use_trans_sid', '0');
@ini_set('display_errors','on');
@ini_set('default_charset',wc_charset);
@ini_set('mbstring.func_overload','7');
@ini_set('mbstring.internal_encoding',wc_charset);
@ini_set('mbstring.internal_encoding',wc_charset);
session_start();

//dumpVariables("start");

require wc_inc_path.'/inc/classes/chrono.class.php';

require wc_inc_path.'/inc/lib/constants.lib.php';

// conf
require wc_inc_path.'/inc/classes/WiclearIni.conf.php';
require wc_inc_path.'/inc/classes/ini.class.php';
$ini = new ini(wc_inc_path.'/conf/config.ini');
$ini->importConstants();

require wc_inc_path.'/inc/lib/url.lib.php';
$app_path = createWebAppPath();
$admin_app_path = $app_path.'admin/';

// db
require wc_inc_path.'/inc/classes/db_connection.class.php';
require wc_inc_path.'/inc/classes/mysql.class.php';
$con = new mysql(wc_db_host, wc_db_login, wc_db_password, wc_db_database);

// wiki
require wc_inc_path.'/inc/classes/nested_set_model_helper.class.php';
require wc_inc_path.'/inc/classes/wiki.class.php';
require wc_inc_path.'/admin/inc/classes/admin_wiki.class.php';
$wiki = new admin_wiki($con, wc_db_prefix);

// variables
require wc_inc_path.'/inc/lib/variables.lib.php';

// auth
require wc_inc_path.'/inc/classes/auth.class.php';
require wc_inc_path.'/inc/classes/lang.class.php';
require wc_inc_path.'/inc/classes/user.class.php';
require wc_inc_path.'/inc/classes/group.class.php';
$user = auth::checkRights($wiki);

// helper
require wc_inc_path.'/inc/classes/utf8_helper.class.php';

// translation
require wc_inc_path.'/inc/classes/translation.class.php';
$user_lang = $user->ui_lang;
if ($user_lang != 'en')
{
  $translation = new translation(wc_inc_path.'/admin/i18n/', $user_lang, 'en', '.lang');
}

// help
$help = new lang(wc_inc_path.'/help/', $user_lang, 'en', '.help');

// cache
require wc_inc_path.'/inc/classes/PEAR/Cache_Lite.class.php';
require wc_inc_path.'/inc/classes/WiclearCache.class.php';
/**
 * \brief the cache
 */
$cacheLite = new WiclearCache('', '', '', '');

$mode = '';
if (isset($_GET['mode']))
{
  $mode = varGet('mode');
}

// boxes
require wc_inc_path.'/admin/inc/lib/boxes.lib.php';
handleAdminAction();
?>
