<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

error_reporting(E_ALL);

$path = dirname(__FILE__).'/../';
// let's use a constant instead of a variable so that hacker can't use it to inject something using a require
// on an unprotected directory
define('wc_inc_path', $path);
unset($path);

require wc_inc_path.'/inc/classes/util.class.php';
util::sessionWorkaround(wc_inc_path);

@ini_set('session.use_cookies','1');
@ini_set('session.use_only_cookies','1');
@ini_set('url_rewriter.tags','');
@ini_set('session.use_trans_sid', '0');
session_start();

require wc_inc_path.'inc/classes/ini.class.php';
require wc_inc_path.'inc/classes/WiclearIni.conf.php';
require wc_inc_path.'inc/classes/auth.class.php';
$ini = new ini(wc_inc_path.'/conf/config.ini');
$ini->importConstants();

require wc_inc_path.'inc/lib/url.lib.php';
$app_path = createWebAppPath();
$admin_app_path = $app_path.'admin/';

require wc_inc_path.'inc/lib/variables.lib.php';
$ips = implode(',', auth::getIPs());
setVarSession('login_ips', $ips);

$random = auth::generateRandomText(255);
setVarSession('login_random', $random);

setVarSession('login_date', time());
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=<?php echo wc_charset;?>"/>
    <title><?php echo wc_wiki_name;?> panel admin</title>
    <link rel="stylesheet" type="text/css" href="<?php echo $admin_app_path;?>inc/style.css" media="screen"/>
  </head>
  <body>
  <form class="login" action="check_login.php" method="post">
  <fieldset>
  <legend>Login</legend>
  <p class="field">
    <label for="flogin">Login</label>
    <input type="text" name="login" id="flogin"/>
  </p>
  <p class="field">
    <label for="fpassword">Password</label>
    <input type="password" name="password" id="fpasword"/>
  </p>
  <p class="field">
    <input type="hidden" name="check" value="1"/>
  </p>
  <p class="field">
    <input type="hidden" name="ips" value="<?php echo $ips;?>"/>
  </p>
  <p class="field">
    <input type="hidden" name="random" value="<?php echo $random;?>"/>
  </p>
  <p class="field">
    <input class="submit" type="submit" value="Login"/>
  </p>
  <p class="field"/>
  </fieldset>
  </form>
  <form class="cancel" action="<?php echo $app_path;?>" method="post">
  <fieldset>
  <legend>Get back to wiki</legend>
    <p class="field">
      <input class="submit" type ="submit" value="Get back to wiki"/>
    </p>
    <p class="field"/>
  </fieldset>
  </form>
  </body>
</html>
