<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

function createSpamWords()
{
  global $wiki;

  $spam_word_sql_file = wc_inc_path.'admin/tools/spam_simple_filter/spam_words.sql';

  $db_charset = $wiki->con->htmlCharsetToMySqlCharset(wc_charset);
  if ($wiki->con->createTableFromFile($spam_word_sql_file, $wiki->prefix, $db_charset) === false)
  {
    echo '<h1>'.tr('Error while creating table').' spam_words : '.$wiki->con->error.'</h1>';
  }
}

function delWord($word)
{
  global $wiki;

  $query = <<<SQL
    DELETE FROM {prefix}spam_words
    WHERE word='$word'
SQL;

  $query = str_replace('{prefix}', $wiki->prefix, $query);
  $result = $wiki->con->execute($query);

  return $result;
}

function numberWords()
{
  global $wiki;

  $query = <<<SQL
    SELECT count(id) FROM {prefix}spam_words
SQL;

  $query = str_replace('{prefix}', $wiki->prefix, $query);
  $result = $wiki->con->select1($query);

  return $result[0];
}

function addWord($word)
{
  if (empty($word))
  {
    return;
  }

  global $wiki;

  $query = <<<SQL
    SELECT id FROM {prefix}spam_words
    WHERE word='$word'
SQL;

  $query = str_replace('{prefix}', $wiki->prefix, $query);
  $result = $wiki->con->select($query);

  if (count($result) == 0)
  {
    $query = <<<SQL
      INSERT INTO {prefix}spam_words
      (word) VALUES ('$word')
SQL;

    $query = str_replace('{prefix}', $wiki->prefix, $query);
    $result = $wiki->con->execute($query);
  }

  return $result;
}

function searchWord($word)
{
  global $wiki;

  if (function_exists('mb_strtolower'))
  {
    $word = mb_strtolower($word);
  }
  else
  {
    $word = strtolower($word);
  }

  $query = <<<SQL
    SELECT word
    FROM {prefix}spam_words
    WHERE LOWER(word) LIKE '%$word%';
SQL;

  $query = str_replace('{prefix}', $wiki->prefix, $query);
  $result = $wiki->con->select($query);

  return $result;
}

function onSpamAdmin()
{
  $mode = varPost('mode');
  if ($mode != 'modify')
  {
    return;
  }

  if (isset($_POST['del_word_button']) && isset($_POST['del_word']))
  {
    delWord(varPost('del_word'));
  }
  else
  if (isset($_POST['add_word_button']) && isset($_POST['add_word']))
  {
    addWord(varPost('add_word'));
  }
  else
  if (isset($_POST['search_word_button']) && isset($_POST['search_word']))
  {
    $words = searchWord(varPost('search_word'));

    if (count($words) == 0)
    {
      echo '<p>'.tr('No match').'</p>';
    }
    else
    {
      echo '<ul>';
      foreach ($words as $word)
      {
        echo '<li>'.$word[0].'</li>';
      }
      echo '</ul>';
    }
  }
}

function displaySpamAdmin()
{
  $form = new form(createToolURL('spam_simple_filter'), 'post');
  $form->addFieldSet();
  $form->addLegend(tr('Spam simple filter admin'));
  $form->addHtml('<h1>'.tr('Plugin spam filter is installed').'</h1>');
  $form->addHtml('<p class="field">');
  $form->addHtml(numberWords().' '.tr('registered words'));
  $form->addHtml('</p>');
  $form->addHtml('<p class="field">');
  $form->addButton('del_word_button', tr('Remove a word'));
  $form->addInput('del_word', 'Del a word');
  $form->addHtml('</p>');
  $form->addHtml('<br/>');
  $form->addHtml('<p class="field">');
  $form->addButton('add_word_button', tr('Add a word'), 'action');
  $form->addInput('add_word', 'Add a word');
  $form->addHtml('</p>');
  $form->addHtml('<br/>');
  $form->addHtml('<p class="field">');
  $form->addButton('search_word_button', tr('Search a word'), 'action');
  $form->addInput('search_word', 'Search a word');
  $form->addHtml('</p>');
  $form->addHtml('<p class="field"/>');
  $form->addHidden('check', '1');
  $form->addHidden('mode', 'modify');

  echo $form->toHtml();
}

global $wiki;

// we have some task to perform
if (isset($_POST['check']))
{
  // ok we have to install the table
  $mode = varPost('mode');
  if ($mode == 'create')
  {
    createSpamWords();
  }
}

// verify if table "trackbacks" already exist
if ($wiki->con->tableExists($wiki->prefix.'spam_words') === false)
{
  // table spam_words does not exist yet
  // we have to create it
  $form = new form(createToolURL('spam_simple_filter'), 'post');
  $form->addFieldset();
  $form->addLegend(tr('Spam simple filter installer'));
  $form->addHtml('<h1>'.tr('No table [spam_words]').'</h1>');
  $form->addHtml('<p>'.tr('You appear not to have an SQL table named spam_words').'.</p>');
  $form->addHtml('<p>'.tr('Should I create it for you ?').'</p>');
  $form->addHidden('check', '1');
  $form->addHidden('mode', 'create');
  $form->addButton('submit', tr('Go'), '');
  echo $form->toHtml();
}
else
{
  if (isset($_POST['check']))
  {
    onSpamAdmin();
  }

  displaySpamAdmin();
}

?>