<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

function convertExistingCategoryMetadata()
{
  global $wiki;

  $id = varPost('id');
  $metaToUpdate = array();
  $metaToUpdate[$id] = metadata_close;
  $wiki->updateMetadatas($metaToUpdate);
}

function createCategoryMetadata()
{
  global $wiki;

  $wiki->addMetaDataWithType('category', metadata_close);
}

function handleCategoryValues()
{
  global $wiki;

  $id = varPost('id');

  if (isset($_POST['del_meta_values']) && isset($_POST['values']))
  {
    $wiki->removeClosedValuesFromMetadata(varPost('values'));
  }
  else
  if (isset($_POST['add_meta_value']))
  {
    $value = varPost('metadata_value');

    if (!$wiki->existMetadataClosedValue($id, $value))
    {
      $wiki->addMetadataClosedValue($id, $value);
    }
  }
}

global $wiki;

// we have some task to perform
if (isset($_POST['check']))
{
  // ok we have to install some metadatas
  $mode = varPost('mode');
  if ($mode == 'convert')
  {
    convertExistingCategoryMetadata();
  }
  else
  if ($mode == 'create')
  {
    createCategoryMetadata();
  }
  else
  if ($mode == 'modify')
  {
    handleCategoryValues();
  }
}

// verify if metadata 'category' already exist
$metadata = $wiki->getMetaDataByName('category');
if ($metadata === false)
{
  // metadata does not exist
  // we have to create it
  $form = new form(createToolURL('wiki_blog'), 'post');
  $form->addFieldset();
  $form->addLegend(tr('Wikiblog installer'));
  $form->addHtml('<h1>'.tr('No metadata [category]').'</h1>');
  $form->addHtml('<p>'.tr('You appear not to have a metadata named category').'.</p>');
  $form->addHtml('<p>'.tr('Should I create it for you ?').'</p>');
  $form->addHidden('check', '1');
  $form->addHidden('mode', 'create');
  $form->addButton('submit', tr('Go'), '');
  echo $form->toHtml();
}
else
{
  // metadata exist. Is it of the 'good' type ?
  if ($metadata->type == metadata_open)
  {
    // no, we have to convert it
    $form = new form(createToolURL('wiki_blog'), 'post');
    $form->addFieldset();
    $form->addLegend(tr('Wikiblog installer'));
    $form->addHtml('<h1>'.tr('Convert existing metadata [category]').'</h1>');
    $form->addHtml('<p>'.tr('You already have a metadata named category, but it is not an open metadata').'.</p>');
    $form->addHtml('<p>'.tr('You can change its type in the metadata admin section, or I can do it for you').'.</p>');
    $form->addHtml('<p>'.tr('Warning : all current metadata currently assigned to it will be lost').'</p>');
    $form->addHidden('id', $metadata->id);
    $form->addHidden('check', '1');
    $form->addHidden('mode', 'convert');
    $form->addButton('submit', tr('Go'), '');
    echo $form->toHtml();
  }
  else
  if ($metadata->type == metadata_close)
  {
    $values = $wiki->getClosedMetadataValues($metadata->id);
    $values = array_flip($values);

    // ok good type, handle values
    $form = new form(createToolURL('wiki_blog'), 'post', 'metadata_delete');
    $form->addFieldset();
    $form->addLegend(tr('Wikiblog categories'));
    $form->addHtml('<h1>'.tr('Configuration OK. Enter your categories').'</h1>');
    $form->addHtml('<p class="field">');
    $form->addListBox($values, array(), 'values', 10);
    $form->addHtml('</p>');
    $form->addHtml('<p class="field">');
    $form->addButton('del_meta_values', tr('Remove selected'));
    $form->addHtml('</p>');
    $form->addHtml('<br/>');
    $form->addHtml('<p class="field">');
    $form->addButton('add_meta_value', tr('Add Value'), 'action');
    $form->addInput('metadata_value', 'Metadata value');
    $form->addHtml('</p>');
    $form->addHtml('<p class="field"/>');
    $form->addHidden('id', $metadata->id);
    $form->addHidden('check', '1');
    $form->addHidden('mode', 'modify');
    echo $form->toHtml();
  }
}

?>