<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

error_reporting(E_ALL);
@ini_set('session.use_cookies','1');
@ini_set('session.use_only_cookies','1');
@ini_set('url_rewriter.tags','');
@ini_set('session.use_trans_sid','0');
@ini_set('display_errors','on');

if (!isset($_GET['h']))
{
  exit;
}

$file_path = __FILE__;
$path      = dirname(__FILE__).'/';
// let's use a constant instead of a variable so that hacker can't use it to inject something using a require
// on an unprotected directory
define('wc_inc_path', $path);
unset($path);

// conf
require wc_inc_path.'/inc/classes/WiclearIni.conf.php';
require wc_inc_path.'/inc/classes/ini.class.php';

/**
 * \brief global configuration variable
 */
$ini = new ini(wc_inc_path.'/conf/config.ini');
$ini->importConstants();

// variables
require wc_inc_path.'/inc/lib/variables.lib.php';

$ui_lang = 'en';
if (isset($_GET['lang']))
{
  $ui_lang = varGet('lang');
}

// translations
require wc_inc_path.'/inc/classes/translation.class.php';

// always translate in the lang specified in the user's preferences
if ($ui_lang != 'en')
{
  $translation = new translation(wc_inc_path.'/i18n', $ui_lang, 'en', '.lang');
}

// help
$help = new translation(wc_inc_path.'/help/', $ui_lang, 'en', '.help');
$helpTopic = varGet('h');

// urls
require wc_inc_path.'/inc/lib/url.lib.php';
$app_path = createWebAppPath();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<? echo $ui_lang; ?>" lang="<? echo $ui_lang; ?>">
<head>
  <title><? echo wc_wiki_name.' '.$helpTopic.' '.tr('Help'); ?></title>
  <link rel="stylesheet" type="text/css" href="<? echo $app_path; ?>themes/dokuwiki/popup.css" />
</head>
<body class="popup">
  <div id="main">
    <div id="content">
    <? echo $help->get($helpTopic); ?>
    </div>
    <p class="small center"><a href="#" onclick="window.close();"><? echo tr('Close this window'); ?></a></p>
  </div>
</body>
</html>
