<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

class WiclearCache extends Cache_Lite
{
  var $user_id;
  var $mode;
  var $title;
  var $lang;
  var $id;

  function WiclearCache($user_id, $mode, $title, $lang)
  {
    $this->user_id = $user_id;
    $this->mode    = $mode;
    $this->title   = $title;
    $this->lang    = $lang;
    $this->id      = $this->title.'-'.$this->lang;

    $cacheDir = wc_inc_path.wc_cache_path.'/';

    if (!file_exists($cacheDir))
    {
      @mkdir($cacheDir);
    }

    // Set a few options
    $options = array(
      'cacheDir' => $cacheDir,
      'lifeTime' => 60*60*24
    );

    $this->Cache_Lite($options);
  }

  function wcGet()
  {
    if (wc_activate_cache === 'true' && empty($this->mode))
    {
      return Cache_Lite::get($this->user_id, $this->id, false);
    }

    return false;
  }

  function wcSave($data)
  {
    if (wc_activate_cache === 'true' && empty($this->mode))
    {
      return Cache_Lite::save($data, $this->user_id, $this->id);
    }

    return false;
  }

  function wcClean()
  {
    Cache_Lite::clean(cache_global_pages_name);
    return Cache_Lite::clean($this->id);
  }

  function wcCleanAll()
  {
    return Cache_Lite::clean();
  }
}
?>