<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

/**
 * \brief generates an atom feed
 *
 * when called this method will generate the appropriate header
 */
class atom extends feed
{
  function headers($charset)
  {
    header('Content-Type: application/atom+xml; charset='.$charset);
    header('Content-Disposition: inline; filename=feed_atom.xml');
  }

  function generate()
  {
    $blob = '<?xml version="1.0" encoding="'.$this->charset.'"?>'."\n".
    '<feed xmlns="http://www.w3.org/2005/Atom" xml:lang="'.$this->lang.'">'."\n".
    '<id>'.$this->feedUrl.'</id>'."\n".
    '<title>'.$this->title.'</title>'."\n".
    '<subtitle>'.$this->description.'</subtitle>'."\n".
    '<link href="'.$this->siteUrl.'"/>'."\n".
    '<link rel="self" href="'.$this->feedUrl.'"/>'."\n".
    '<updated>'.date_helper::getISO8601Date($this->mostRecent).'</updated>'."\n".
    '<generator uri="http://wiclear.free.fr/" >Wiclear</generator>'."\n";

    foreach ($this->items as $item)
    {
      $blob .=
      '<entry xml:lang="'.$item->lang.'">'."\n".
      '     <id>'.$item->url.'</id>'."\n".
      '     <title>'.$item->title.'</title>'."\n".
      '     <updated>'.date_helper::getISO8601Date($item->date).'</updated>'."\n".
      '     <author><name>'.$item->author.'</name></author>'."\n".
      '     <link rel="alternate" href="'.$item->url.'" />'."\n";
      if($item->content['type'] == 'text')
      {
        $blob .= '     <summary type="text">'.$this->summary($item->content['content']).'</summary>'."\n";
      }
      //$blob .= '     <content type="'.$item->content['type'].'" ><div xmlns="http://www.w3.org/1999/xhtml">'.$item->content['content'].'</div></content>'."\n";
      $blob .= '     <content type="'.$item->content['type'].'" >'.$item->content['content'].'</content>'."\n";
      $blob .= '</entry>'."\n";
    }

    $blob .= '</feed>';

    return $blob;
  }
}

?>
