<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

/**
 * \brief represents an ACL group
 *
 * list of user belonging to this group have write access to nodes having this group in their ACL list
 */
class group
{
  var $id;    //!< database id
  var $name;  //!< name of this group
  var $users; //!< map<if, login>

  function group($id, $name)
  {
    $this->id    = $id;
    $this->name  = $name;
    $this->users = array();
  }

  /**
   * \brief add a user to this group
   *
   * \param id database id of user to add
   * \param login login of user
   */
  function addUser($id, $login)
  {
    $this->users[$id] = $login;
  }

  /**
   * \brief does a user belongs to this group
   *
   * \param user user object
   * \return true if user belongs to this group, false otherwise
   */
  function validates($user)
  {
    return array_key_exists($user->id, $this->users);
  }
}
?>