<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

/**
 * \brief represents a metadata
 *
 * a metadata has a name or a type (open or close).
 * an Open metadata means the user can provide whatever value he wants, while a Closed
 * metadata means the user can only select into a list of predefined values.
 */
class metadata
{
  var $id;   //!< database id
  var $name; //!< name of this metadata
  var $type; //!< type of metadata (0 = open, 1 = close as defined in constants.lib.php)

  function metadata($id, $name, $type)
  {
    $this->id   = $id;
    $this->name = $name;
    $this->type = $type;
  }
}
?>