<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

/**
 * \brief generates a 0.91 feed
 *
 * when called this method will generate the appropriate header
 */
class rss_2 extends feed
{
  function headers($charset)
  {
    header('Content-Type: application/xml; charset='.$charset);
  }

  function generate()
  {
    $blob =
    '<?xml version="1.0" encoding="'.$this->charset.'"?>'."\n".
    '<rss version="2.0">'."\n".
    '<channel>'."\n".
    '  <title>'.$this->title.'</title>'."\n".
    '  <link>'.$this->siteUrl.'</link>'."\n".
    '  <description>'.$this->description.'</description>'."\n".
    '  <language>'.$this->lang.'</language>'."\n".
    '  <pubDate>'.date_helper::getRFC2822Date($this->mostRecent).'</pubDate>'."\n".
    '  <generator>Wiclear</generator>'."\n";

    foreach ($this->items as $item)
    {
      $blob .=
      '  <item>'."\n".
      '    <guid>'.$item->url.'</guid>'."\n".
      '    <title>'.$item->title.'</title>'."\n".
      '    <link>'.$item->url.'</link>'."\n".
      '    <description>'.htmlspecialchars($item->content['content']).'</description>'."\n".
      '    <pubDate>'.date_helper::getRFC2822Date($item->date).'</pubDate>'."\n".
      '  </item>'."\n";
    }

    $blob .=
    '</channel>'."\n".
    '</rss>';

    return $blob;
  }
}
?>
