<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

class table
{
  var $columns; // array()
  var $data;    // array(array()) rows then columns
  var $classes; // array() one class per row

  function table($columns)
  {
    $this->columns = $columns;
    // reserve arrays
    $this->data    = array();
    $this->classes = array();
  }

  function push_row($row, $class = '')
  {
    //assert(count($row) == count($this->columns));
    $this->data[]    = $row;
    $this->classes[] = $class;
  }

  function set_data($data, $classes = array())
  {
    $this->data = $data;
    $this->classes = $classes;
  }
}

class HtmlTableRenderer
{
  function render($table)
  {
    $blob = '<table><tr>';
    foreach ($table->columns as $c)
    {
      $blob .= '<th>'.$c.'</th>';
    }
    $blob .= '</tr>';
    for ($i = 0; $i < count($table->data); ++$i)
    {
      $row   = $table->data[$i];
      $class = $table->classes[$i];

      if (empty($class))
      {
        $blob .= '<tr>';
      }
      else
      {
        $blob .= '<tr class="'.$class.'">';
      }

      foreach ($row as $cell)
      {
        $blob .= '<td>'.$cell.'</td>';
      }
      $blob .= '</tr>';
    }
    $blob .= '</table>';

    return $blob;
  }
}

class HtmlBigDivTableRenderer
{
  function render($table)
  {
    $blob = '';
    for ($i = 0; $i < count($table->data); ++$i)
    {
      $row    = $table->data[$i];
      $class  = $table->classes[$i];

      if (empty($class))
      {
        $blob .= '<div>';
      }
      else
      {
        $blob .= '<div class="'.$class.'">';
      }

      for ($j = 0; $j < count($row); ++$j)
      {
        $cell   = $row[$j];
        if (empty($cell))
        {
          continue;
        }

        $column = $table->columns[$j];
        $blob .= '<p>'.$column.' : '.$cell.'</p>';
      }
      $blob .= '</div><hr />';
    }

    return $blob;
  }
}
?>
