<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

/**
 * \file
 * \brief Controls error display
 *
 * This page contains also several helper functions for the user to report error:
 * <ul>
 *   <li>errorMessage</li>
 *   <li>errorMessageACLRead</li>
 * </ul>
 */


/**
 * \brief display an error message
 *
 * \return html blob
 */
function errorMessage ($msg)
{
  return '<div class="error"><strong>'.$msg.'</strong></div>';
}

/**
 * \brief display an error message concerning ACL read permission
 *
 * \return html blob
 */

function errorMessageACLRead ()
{
  return errorMessage(tr('Sorry, you do not have enough rights to see this page'));
}

?>
