<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

require 'prepend.php';
require '../inc/classes/WiclearIni.conf.php';
require '../inc/classes/ini.class.php';
require '../inc/classes/db_connection.class.php';

$db_charset = varSession('db_charset');
$htmlCharset = 'ISO-8859-1';
if (!empty($db_charset))
{
  $htmlCharset = db_connection::mySqlCharsetToHtmlCharset($db_charset);
}

$ini = new ini('../conf/config.ini');
$ini->addConstant('wc_db_host',      varSession('db_host'));
$ini->addConstant('wc_db_login',     varSession('db_login'));
$ini->addConstant('wc_db_password',  varSession('db_password'));
$ini->addConstant('wc_db_database',  varSession('db_database'));
$ini->addConstant('wc_db_prefix',    varSession('db_prefix'));
$ini->addConstant('wc_charset',      $htmlCharset);
$ini->addConstant('wc_default_lang', varSession('wiki_default_lang'));
$ini->addConstant('wc_wiki_name',    varSession('wiki_name'));
$ini->addConstant('wc_path',         varSession('wiki_path'));
$ini->addConstant('wc_mail',         varSession('wiki_email'));
$ini->completeFromDefault();

if ($ini->saveFile())
{
  define('wc_charset', 'ISO-8859-1');
  require '../inc/classes/form.class.php';

  echo
  '<p>'.tr('Configuration created, your wiki is now ready to be used').'</p>';

  $form = new form('../admin', 'post');

  $form->addHtml('<p class="field">');
  $form->addButton('submit', tr('Manage your wiki'));
  $form->addHtml('</p>');

  echo $form->toHtml();
}
else
{
  echo
  '<p>'.tr('Error : could not create configuration file').'</p>';
}

require 'append.php';
?>
