<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

require 'prepend.php';

$user_login        = '';
$user_fname        = '';
$user_lname        = '';
$user_password     = '';
$user_email        = '';
$user_lang         = 'en';

require '../inc/classes/chrono.class.php';
require '../inc/classes/db_connection.class.php';
require '../inc/classes/mysql.class.php';
$con = new mysql(varSession('db_host'), varSession('db_login'), varSession('db_password'), varSession('db_database'));
$prefix = varSession('db_prefix');

require '../inc/classes/wiki.class.php';
require '../admin/inc/classes/admin_wiki.class.php';
require '../inc/classes/auth.class.php';
require '../inc/classes/user.class.php';
require '../inc/classes/lang.class.php';
$wiki = new admin_wiki($con, $prefix);

$created = false;
if (existVarPost('check'))
{
  require '../inc/lib/constants.lib.php';

  $user_login        = varPost('login');
  $user_fname        = varPost('fname');
  $user_lname        = varPost('lname');
  $user_password     = varPost('password');
  $user_email        = varPost('email');
  $user_content_lang = varPost('user_content_lang');
  $user_ui_lang      = varPost('user_ui_lang');

  $wiki->addAdministrator($user_login, $user_fname, $user_lname, $user_password, $user_email, $user_content_lang, $user_ui_lang);
  $user = $wiki->findUser($user_login, $user_password);
  setVarSession('user_id',       $user->id);
  setVarSession('user_password', $user->password);
  $con->close();

  $created = true;
}

define('wc_charset', 'ISO-8859-1');
require '../inc/classes/form.class.php';

if ($created)
{
  echo
  '<p>'.tr('User created !').'</p>';

  $form = new form('create_conf.php', 'post');

  $form->addHtml('<p class="field">');
  $form->addButton('submit', tr('Finish configuration'));
  $form->addHtml('</p');

  echo $form->toHtml();
}
else
{
  require '../inc/lib/lang_helper.lib.php';
  $file_path = __FILE__;
  $path      = dirname(__FILE__).'/../';
  $wikiLangs = $wiki->getLangs();
  $langs = array();
  foreach ($wikiLangs as $lang)
  {
    $langs[$lang->code] = $lang->id;
  }

  echo
  '<h1>'.tr('Step').' 4/4 : '.tr('User creation').'</h1>';

  $form = new form('create_user.php', 'post', 'framed');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('User login'), 'flogin');
  $form->addInput('login', 'Login', $user_login, 'flogin');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('User first name'), 'ffname');
  $form->addInput('fname', 'First name', $user_fname, 'ffname');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('User last name'), 'flname');
  $form->addInput('lname', 'Last name', $user_lname, 'flname');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('User password'), 'fpassword');
  $form->addInput('password', 'Password', $user_password, 'fpassword');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('User email'), 'femail');
  $form->addInput('email', 'Email', $user_email, 'femail');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('Preferred lang for content'), 'fcontent_lang');
  $form->addDropDown($langs, 'en', 'user_content_lang', 'fcontent_lang');
  $form->addHtml('</p>');

  $langBaseDir = $path.'/i18n/';
  $langsUI = lang::getUILangs($langBaseDir);

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('Preferred lang for interface'), 'fui_lang');
  $form->addDropDown($langsUI, 'en', 'user_ui_lang', 'fui_lang');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addHidden('check', '1');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addButton('submit', tr('Create User'), 'action');
  $form->addHtml('</p>');

  echo $form->toHtml();
}

require 'append.php';
?>
