<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

require 'prepend.php';

$wiki_default_lang = 'en';
$wiki_name         = '';
$wiki_path         = dirname(dirname($_SERVER['REQUEST_URI']));
$wiki_email        = 'webmaster@'.$_SERVER['SERVER_NAME'];

require '../inc/classes/chrono.class.php';
require '../inc/classes/db_connection.class.php';
require '../inc/classes/mysql.class.php';
$con = new mysql(varSession('db_host'), varSession('db_login'), varSession('db_password'), varSession('db_database'));
$prefix = varSession('db_prefix');

require '../inc/lib/constants.lib.php';
require '../inc/classes/nested_set_model_helper.class.php';
require '../inc/classes/wiki.class.php';
require '../admin/inc/classes/admin_wiki.class.php';
require '../inc/classes/auth.class.php';
require '../inc/classes/user.class.php';
require '../inc/classes/lang.class.php';
define('wc_default_lang', $wiki_default_lang);
$wiki = new admin_wiki($con, $prefix);

$created = false;
if (!empty($_POST['check']))
{
  $wiki_default_lang = varPost('wiki_default_lang');
  $wiki_name         = varPost('wiki_name');
  $wiki_path         = varPost('wiki_path');
  $wiki_email        = varPost('wiki_email');

  $lang_id = lang::getIdFromCode($wiki->getLangs(), $wiki_default_lang);

  $wiki->addAnonymous($lang_id);
  $expected_root_id = 0;
  $root_id = $wiki->addContent(
    $expected_root_id,
    'Wiclear installation successful',
    '',
    'Edit this page',
    'Installation successfull',
    major_value,
    $lang_id,
    0,
    $wiki->anonymousUser()
  );
  $wiki->fixParentId($root_id, $root_id);

  $con->close();

  $created = true;
}

define('wc_charset', 'ISO-8859-1');
require '../inc/classes/form.class.php';

if ($created)
{
  setVarSession('wiki_default_lang', $wiki_default_lang);
  setVarSession('wiki_name',         $wiki_name);
  setVarSession('wiki_path',         $wiki_path);
  setVarSession('wiki_email',        $wiki_email);

  echo
  '<p>'.tr('Wiki conf registered !').'</p>';

  $form = new form('create_user.php', 'post');

  $form->addHtml('<p class="field">');
  $form->addButton('submit', tr('Create user').'&gt;&gt;');
  $form->addHtml('</p>');

  echo $form->toHtml();
}
else
{
  require '../inc/lib/lang_helper.lib.php';
  $file_path = __FILE__;
  $path      = dirname(__FILE__).'/../';
  $wikiLangs = $wiki->getLangs();
  $langs = array();
  foreach ($wikiLangs as $lang)
  {
    $langs[] = $lang->code;
  }

  echo
  '<h1>'.tr('Step').' 3/4 : '.tr('Wiki configuration').'</h1>';

  $form = new form('create_wiki.php', 'post', 'framed');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('Default Lang'), 'fdefault_lang');
  $form->addDropDown($langs, 'en', 'wiki_default_lang', 'fdefault_lang', 1);
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('Wiki name'), 'fwiki_name');
  $form->addInput('wiki_name', 'Wiki name', $wiki_name, 'fwiki_name');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr("path of wiclear from server's root"), 'fwiki_path');
  $form->addInput('wiki_path', 'Path', $wiki_path, 'fwiki_path');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addLabel(tr('Reply-to email address'), 'fwiki_email');
  $form->addInput('wiki_email', 'Email', $wiki_email, 'fwiki_email');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addHidden('check', '1');
  $form->addHtml('</p>');

  $form->addHtml('<p class="field">');
  $form->addButton('submit', tr('Create Wiki configuration'), 'action');
  $form->addHtml('</p>');

  echo $form->toHtml();
}

require 'append.php';
?>
