<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

require 'prepend.php';
require '../inc/classes/chrono.class.php';
require '../inc/classes/db_connection.class.php';
require '../inc/classes/mysql.class.php';

$con = new mysql(varSession('db_host'), varSession('db_login'), varSession('db_password'), varSession('db_database'));
$prefix  = varSession('db_prefix');
$charset = varSession('db_charset');

require '../inc/classes/check_list.class.php';
define('wc_charset', 'ISO-8859-1');
require '../inc/classes/form.class.php';
$check = new check_list('ok', 'nok');

$tablesBaseDir = 'tables/';
if (file_exists($tablesBaseDir))
{
  $h = opendir($tablesBaseDir);
  while (($file = readdir($h)) !== false)
  {
    $tableName = basename($file, '.sql');

    if (file_exists($tablesBaseDir.$tableName.'.sql'))
    {
      $check->addItem(
        $con->createTableFromFile($tablesBaseDir.$file, $prefix, $charset),
        tr('Table').' '.$tableName.' '.tr('successfully created'),
        tr('Error while creating table').' '.$tableName.' : '.$con->error
      );
    }
  }
  closedir($h);
}

echo $check->htmlReport();

if ($check->allOK())
{
  echo tr('Tables successfully created');

  require '../inc/lib/constants.lib.php';
  require '../inc/classes/wiki.class.php';
  require '../admin/inc/classes/admin_wiki.class.php';
  $wiki = new admin_wiki($con, $prefix);
  $wiki->addLang('en', 'English',  'flag_en.png');
  $wiki->addLang('fr', 'Fran&ccedil;ais', 'flag_fr.png');
  $wiki->addLang('de', 'German',   'flag_de.png');
  $wiki->addLang('ru', 'Russian',  'flag_ru.png');
  $wiki->addLang('sl', 'Slovene',  'flag_sl.png');
  $wiki->addLang('nl', 'Dutch',    'flag_nl.png');
  $wiki->addLang('it', 'Italy',    'flag_it.png');
  $wiki->addLang('es', 'Spain',    'flag_es.png');

  $form = new form('create_wiki.php', 'post', 'tables_ok');
  $form->addHtml('<p class="field">');
  $form->addButton('submit', tr('Create Wiki configuration'), 'submit');
  $form->addHtml('</p>');

  echo $form->toHtml();
}
else
{
  echo tr('Errors were reported');
}

require 'append.php';
?>
