<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

global $updateInfo;
$updateInfo['0.10'] = array('0.11', 'updateFrom0dot10To0dot11');

function updateFrom0dot10To0dot11($wiki, $ini)
{
  $check = new check_list('ok', 'nok');

  // alter table content_group
  // add a user_fk field
  $query = <<<SQL
    ALTER TABLE {prefix}content_group
    ADD user_fk int(6),
    CHANGE group_fk group_fk int(6)
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  if ($ok)
  {
    // force value to NULL
    $default_value = acl_write;
    $query = <<<SQL
      UPDATE {prefix}content_group
      SET user_fk='NULL'
SQL;

    $query = str_replace('{prefix}', wc_db_prefix, $query);
    $ok = $wiki->con->execute($query);
  }

  $check->addItem(
    $ok,
    tr('Table content_group successfully modified'),
    tr('Error while modifying table content_group : ').$wiki->con->error
  );

  // report
  echo $check->htmlReport();

  return $check->allOK();
}

?>

