<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

global $updateInfo;
$updateInfo['0.11'] = array('0.12', 'updateFrom0dot11To0dot12');

function updateFrom0dot11To0dot12($wiki, $ini)
{
  $check = new check_list('ok', 'nok');

  // alter table comment
  $query = <<<SQL
    ALTER TABLE {prefix}comment
    CHANGE ip ip varchar(255),
    CHANGE name name char(50)
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  $check->addItem(
    $ok,
    tr('Table comment successfully modified'),
    tr('Error while modifying table comment : ').$wiki->con->error
  );

  // alter table content
  $query = <<<SQL
    ALTER TABLE {prefix}content
    CHANGE ip ip varchar(255)
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  $check->addItem(
    $ok,
    tr('Table content successfully modified'),
    tr('Error while modifying table content : ').$wiki->con->error
  );

  // alter table history
  $query = <<<SQL
    ALTER TABLE {prefix}history
    CHANGE ip ip varchar(255)
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  $check->addItem(
    $ok,
    tr('Table history successfully modified'),
    tr('Error while modifying table history : ').$wiki->con->error
  );

  // alter table attachments
  $query = <<<SQL
    ALTER TABLE {prefix}attachments
    CHANGE ip ip varchar(255)
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  $check->addItem(
    $ok,
    tr('Table attachments successfully modified'),
    tr('Error while modifying table attachments : ').$wiki->con->error
  );

  // report
  echo $check->htmlReport();

  return $check->allOK();
}

?>

