<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

global $updateInfo;
$updateInfo['0.7'] = array('0.8', 'updateFrom0dot7To0dot8');

function updateFrom0dot7To0dot8($wiki, $ini)
{
  $check = new check_list('ok', 'nok');

  // create metadata table
  $query = <<<SQL
  CREATE TABLE {prefix}metadata
  (
    id int(6)    NOT NULL auto_increment,
    name         char(100) NOT NULL,
    type         int(1) NOT NULL,

    PRIMARY      KEY (id)
  );
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  $check->addItem(
    $ok,
    tr('Table metadata successfully created'),
    tr('Error while creating table metadata : ').$wiki->con->error
  );

  // create metadata_content table
  $query = <<<SQL
  CREATE TABLE {prefix}metadata_content
  (
    id                int(6)   NOT NULL auto_increment,
    content_fk        int(6)   NOT NULL,
    metadata_fk       int(6)   NOT NULL,
    metadata_value_fk int(6),
    value             blob,

    PRIMARY           KEY (id)
  );
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  $check->addItem(
    $ok,
    tr('Table metadata_content successfully created'),
    tr('Error while creating table metadata_content : ').$wiki->con->error
  );

  // create metadata_value table
  $query = <<<SQL
  CREATE TABLE {prefix}metadata_value
  (
    id                int(6)   NOT NULL auto_increment,
    metadata_fk       int(6)   NOT NULL,
    value             blob,

    PRIMARY           KEY (id)
  );
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  $check->addItem(
    $ok,
    tr('Table metadata_value successfully created'),
    tr('Error while creating table metadata_value : ').$wiki->con->error
  );

  // alter table user
  // add a lang_ui code
  $query = <<<SQL
    ALTER TABLE {prefix}user
    ADD lang_ui char(3) NOT NULL
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  if ($ok)
  {
    // force value to wc_default_lang for new lang_ui field
    $default_lang = wc_default_lang;
    $query = <<<SQL
      UPDATE {prefix}user
      SET lang_ui='$default_lang'
SQL;

    $query = str_replace('{prefix}', wc_db_prefix, $query);
    $ok = $wiki->con->execute($query);
  }

  $check->addItem(
    $ok,
    tr('Table user successfully modified'),
    tr('Error while modifying table user : ').$wiki->con->error
  );

  // alter table content
  // add a creation_time timestamp
  $query = <<<SQL
    ALTER TABLE {prefix}content
    ADD creation_time int(8)
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  if ($ok)
  {
    $query = <<<SQL
      SELECT {prefix}content.id
      FROM {prefix}content
SQL;

    $query = str_replace('{prefix}', wc_db_prefix, $query);
    $result = $wiki->con->select($query);
    foreach ($result as $r)
    {
      $id = $r[0];

      $query = <<<SQL
        SELECT {prefix}history.timestamp
        FROM   {prefix}history
        WHERE  {prefix}history.content_fk='$id'
        ORDER BY {prefix}history.timestamp DESC LIMIT 1
SQL;
      $query = str_replace('{prefix}', wc_db_prefix, $query);
      $timestamp = $wiki->con->select1($query);
      $timestamp = $timestamp[0];

      $query = <<<SQL
        UPDATE {prefix}content
        SET creation_time='$timestamp'
        WHERE id='$id'
SQL;
      $query = str_replace('{prefix}', wc_db_prefix, $query);
      $timestamp = $wiki->con->execute($query);
    }
  }

  $check->addItem(
    $ok,
    tr('Table content successfully modified'),
    tr('Error while modifying table content : ').$wiki->con->error
  );

  // report
  echo $check->htmlReport();

  return $check->allOK();
}

?>
