<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of WiClear.
# Copyright (c) 2004-2007 David Jobet. All rights
# reserved.
#
# WiClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WiClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
#
# ***** END LICENSE BLOCK *****

global $updateInfo;
$updateInfo['0.8'] = array('0.9', 'updateFrom0dot8To0dot9');

function updateFrom0dot8To0dot9($wiki, $ini)
{
  $check = new check_list('ok', 'nok');

  // create table attachments
  $query = <<<SQL
  CREATE TABLE {prefix}attachments
  (
    id                 int(6)    NOT NULL auto_increment,
    file_name          char(100) NOT NULL,
    timestamp          int(8),
    ip                 char(15),

    user_fk            int (6),
    content_fk         int(6),

    PRIMARY            KEY (id)
  );
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  $check->addItem(
    $ok,
    tr('Table attachments successfully created'),
    tr('Error while creating table attachments : ').$wiki->con->error
  );

  // alter table content
  // add a commit_msg field
  // add a minor_major field
  $query = <<<SQL
    ALTER TABLE {prefix}content
    ADD commit_msg varchar(200),
    ADD minor_major int(1)
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  if ($ok)
  {
    // force value to wc_major for new minor_major field
    $default_value = major_value;
    $query = <<<SQL
      UPDATE {prefix}content
      SET minor_major='$default_value'
SQL;

    $query = str_replace('{prefix}', wc_db_prefix, $query);
    $ok = $wiki->con->execute($query);
  }

  $check->addItem(
    $ok,
    tr('Table content successfully modified'),
    tr('Error while modifying table content : ').$wiki->con->error
  );

  // alter table history
  // add a commit_msg field
  $query = <<<SQL
    ALTER TABLE {prefix}history
    ADD commit_msg varchar(200),
    ADD minor_major int(1)
SQL;

  $query = str_replace('{prefix}', wc_db_prefix, $query);
  $ok = $wiki->con->execute($query);

  if ($ok)
  {
    // force value to wc_major for new minor_major field
    $default_value = major_value;
    $query = <<<SQL
      UPDATE {prefix}history
      SET minor_major='$default_value'
SQL;

    $query = str_replace('{prefix}', wc_db_prefix, $query);
    $ok = $wiki->con->execute($query);
  }

  $check->addItem(
    $ok,
    tr('Table history successfully modified'),
    tr('Error while modifying table history : ').$wiki->con->error
  );

  // report
  echo $check->htmlReport();

  return $check->allOK();
}

?>
